#ifndef THREAD_H_INCLUDED_
#define THREAD_H_INCLUDED_

#include <vector>

#include "rose.h"

#include "class.h"
#include "event.h"
#include "function.h"
#include "port.h"

namespace risc {

class Event;
class Port;

typedef std::vector<Event*> EventVector;
typedef std::vector<Port*> PortVector;

class Thread: public Function {

public:

  /**
   * \brief Default constructor
   */
  explicit Thread(SgFunctionDefinition *ast_node, Class *parent);


  EventVector static_event_sensitivity_list_;
  PortVector static_port_sensitivity_list_;

  /**
   * \brief Prints the static event list of the method
   */
  void print_event_list();

private:
  /**
   * \brief Disabled copy constructor
   */
  Thread(const Thread &t);
};

typedef std::vector<Thread*> ThreadVector;
typedef std::vector<Thread*>::iterator ThreadVectorIter;
typedef std::vector<Thread*>::const_iterator ThreadVectorConstIter;

} // end namespace risc

#endif /* THREAD_H_INCLUDED_ */

/* ex: set softtabstop=2 tabstop=2 shiftwidth=2 expandtab: */
