#include "systemc.h"
#if 0
class A: public sc_module {
public:
  SC_HAS_PROCESS(A);

  sc_fifo_in<int> port_in_a;
  sc_fifo_out<int> port_out_a;

  A(sc_module_name mn):
    sc_module(mn)
  {
    SC_THREAD(thread1);
  }

  void thread1()
  {
    int i;
    i = port_in_a->read();
    port_out_a->write(i);

  }
};

class B: public sc_module {
public:
  SC_HAS_PROCESS(B);

  sc_fifo_out<int> port_out_b;

  B(sc_module_name mn):
    sc_module(mn)
  {
    SC_THREAD(thread1);
  }

  void thread1()
  {
    port_out_b->write(42);
  }
};

class C: public sc_module {
public:
  SC_HAS_PROCESS(C);

  sc_fifo_in<int> port_in_c;
  sc_fifo_out<int> port_out_c;

  C(sc_module_name mn):
    sc_module(mn)
  {
    SC_THREAD(thread1);
  }

  void thread1()
  {
    int i;
    i = port_in_c->read();
    port_out_c->write(i);
  }
};

class E: public sc_module {
public:
  SC_HAS_PROCESS(E);

  sc_fifo_in<int> port_in_e;

  E(sc_module_name mn):
    sc_module(mn)
  {
    SC_THREAD(thread1);
  }

  void thread1()
  {
    int i;
    i = port_in_e->read();

    std::cout << "receiving: " << i << std::endl;
  }
};

class D: public sc_module {
public:

  E e;

  SC_HAS_PROCESS(D);

  sc_fifo_in<int> port_in_d;

  D(sc_module_name mn):
    sc_module(mn),
    e("e")
  {
    SC_THREAD(thread1);
  }

  void thread1()
  { }

  void before_end_of_elaboration()
  {
    e.port_in_e.bind(port_in_d);
  }
};

class Channel: public sc_channel {

public:
  Channel(sc_module_name mn):
    sc_channel(mn)
  { }
};

class Top: public sc_module {
public:

  A a;
  B b;
  C c;
  D d;
  Channel channel;



  sc_fifo<int> f_ab;
  sc_fifo<int> f_ac;
  sc_fifo<int> f_cd;

  Top(sc_module_name mn):
    sc_module(mn),
    a("a"),
    b("b"),
    c("c"),
    d("d"),
    channel("channel")
  { }

  void before_end_of_elaboration()
  {
    b.port_out_b.bind(f_ab);
    a.port_in_a.bind(f_ab);

    a.port_out_a.bind(f_ac);
    c.port_in_c.bind(f_ac);

    c.port_out_c.bind(f_cd);
    d.port_in_d.bind(f_cd);
  }
};
#endif


class A: public sc_module {
public:

  sc_fifo_out<int> port_out_a;

  A(sc_module_name mn):
    sc_module(mn)
  { }
};

class B: public sc_module {
public:

  sc_fifo_out<int> port_in_b;

  B(sc_module_name mn):
    sc_module(mn)
  { }
};


class C: public sc_module {
public:

  A a1;
  A a2;

  sc_fifo_out<int> port_out_c1;
  sc_fifo_out<int> port_out_c2;

  C(sc_module_name mn):
    sc_module(mn),
    a1("a1"),
    a2("a2")
  { }

  void before_end_of_elaboration()
  {
    a1.port_out_a.bind(port_out_c1);
    a2.port_out_a.bind(port_out_c2);
  }
};

class D: public sc_module {
public:

  A a;
  B b;
  B b1;
  B b2;
  C c;

  sc_fifo<int> ch;
  sc_fifo<int> ch1;
  sc_fifo<int> ch2;

  D(sc_module_name mn):
    sc_module(mn),
    a("a"),
    b("b"),
    b1("b1"),
    b2("b2"),
    c("c")
  { }

  void before_end_of_elaboration()
  {
//    a.port_out_a.bind(ch); // This should cause an error
    b.port_in_b.bind(ch);

    c.port_out_c1.bind(ch1);
    c.port_out_c2.bind(ch2);
    b1.port_in_b.bind(ch1);
    b2.port_in_b.bind(ch2);
  }
};

class Top2: public sc_module {
public:

  D d1;
  D d2;

  Top2(sc_module_name mn):
    sc_module(mn),
    d1("d1"),
    d2("d2")
  { }

  void before_end_of_elaboration()
  { }
};

int sc_main(int argc, char **argv)
{
//  Top t("top");
  Top2 t2("top1");
  sc_start();
  return 0;
}
