/*****************************************************************************

  The following code is derived, directly or indirectly, from the SystemC
  source code Copyright (c) 1996-2006 by all Contributors.
  All Rights reserved.

  The contents of this file are subject to the restrictions and limitations
  set forth in the SystemC Open Source License Version 2.4 (the "License");
  You may not use this file except in compliance with such restrictions and
  limitations. You may obtain instructions on how to receive a copy of the
  License at http://www.systemc.org/. Software distributed by Contributors
  under the License is distributed on an "AS IS" basis, WITHOUT WARRANTY OF
  ANY KIND, either express or implied. See the License for the specific
  language governing rights and limitations under the License.

 *****************************************************************************/

/*****************************************************************************

  simple_fifo.cpp -- Simple SystemC 2.0 producer/consumer example.

                     From "An Introduction to System Level Modeling in
                     SystemC 2.0". By Stuart Swan, Cadence Design Systems.
                     Available at www.systemc.org

  Original Author: Stuart Swan, Cadence Design Systems, 2001-06-18

 *****************************************************************************/

/*****************************************************************************

  MODIFICATION LOG - modifiers, enter your name, affiliation, date and
  changes you are making here.

      Name, Affiliation, Date: Ajit Dingankar, Intel Corporation, 2017-10-09
  Description of Modification: Simple changes to bring closer to SystemC code
  	  generated by Intel(R) CoFluent(TM) Studio

 *****************************************************************************/

#include "fifo.h"

 
fifo::fifo(sc_module_name name) : 
  sc_channel(name), 
  num_elements(0), 
  first(0) 
{  
}
 
void fifo::write(char c) {
  if (num_elements == max)
    wait(read_event);

  data[(first + num_elements) % max] = c;
  ++ num_elements;
  write_event.notify(SC_ZERO_TIME);
}

void fifo::read(char &c) {
  if (num_elements == 0)
    wait(write_event);
  c = data[first];
  -- num_elements;
  first = (first + 1) % max;
  read_event.notify(SC_ZERO_TIME);
}

void  
fifo::reset() { num_elements = first = 0; }

int  
fifo::num_available() { return num_elements;}
