// bug20181220.cc
// WAS: template_class_bug.cpp (reported by DM 11/19/2018)

// LIMITATION/BUG:
// methods defined in templated class definitions are missing in generated code
// (this is a ROSE limitation)

// WORK-AROUND:
// move method definitions outside of the class definition

#include "systemc.h"

template<typename V>
class t_class {		// template class definition shows in instrumented file
public:
bool success;

	t_class();
//	{		// but method bodies are omitted (ROSE limitation)
//		success = false;
//	}

	void func();
//	{
//		success = true;
//	}

};

template<typename V>	// WORK-AROUND: define method bodies here
t_class<V>::t_class() {
	success = false;
}

template<typename V>	// WORK-AROUND: define method bodies here
void t_class<V>::func() {
	success = true;
}

SC_MODULE(TOP) {

	t_class<int> t_object;

	SC_CTOR(TOP) {
		SC_THREAD(behav);
	}

	void behav() {
		t_object.func();
	}
	
};

int sc_main(int argc, char* argv[]) {
	TOP t("t");
	sc_start();
	assert(t.t_object.success == true);
	return 0;
}

// EOF
