// cyclic_notify.cc
// 04/13/17 RD   some cleanup, improved assertions
// 04/04/17 ZC   initial version

#include <stdio.h>
#include "systemc.h"

#define ITERATIONS 50

class Main_Block : public sc_module
{
public:
	sc_event e1;
	sc_event e2;
	sc_event e3;
	int v1, v2, v3;

	void S1()
	{
		int i;
		for(i=0;i<ITERATIONS;i++){
			e1.notify(SC_ZERO_TIME);
			wait(e3);
			v1++;
		}
		assert(i==v1);
	}

	void S2()
	{
		int i;
		for(i=0;i<ITERATIONS;i++){
			wait(e1);
			e2.notify(SC_ZERO_TIME);
			v2++;
		}
		assert(i==v2);
	}

	void S3()
	{
		int i;
		for(i=0;i<ITERATIONS;i++){
			wait(e2);
			e3.notify(SC_ZERO_TIME);
			v3++;
		}
		assert(i==v3);
	}

	Main_Block(sc_module_name name)
	: sc_module(name)
	{
		v1 = v2 = v3 = 0;
		SC_THREAD(S1);
		SC_THREAD(S2);
		SC_THREAD(S3);
	}
	SC_HAS_PROCESS(Main_Block);
};

int sc_main(int argc, char* argv[])
{
	Main_Block m("m");
	printf("cyclic_notify starts\n");
	assert(m.v1 == 0);
	assert(m.v2 == 0);
	assert(m.v3 == 0);
	sc_start();
	assert(m.v1 == ITERATIONS);
	assert(m.v2 == ITERATIONS);
	assert(m.v3 == ITERATIONS);
	printf("cyclic_notify done\n");
	return 0;
}


/* ex: set softtabstop=8 tabstop=8 shiftwidth=8 expandtab: */
