// data_conflict2.cc:
//
// 04/11/19 RD	initial version (to fix conflict_info for pointers,
//		conflict functions, and for diagonal table entries)

#include <stdio.h>
#include "systemc.h"

int	Global = 42;
int	*Ptr = 0;

class One : public sc_module
{
    public:
	int Member;
	static int Static;

	void T()
	{
		int Local;

		Local  = Global;	// SegID 0
		Member = Global;

		wait(1, SC_NS);		// SegID 1
		Global = Local;
		Global = Member;
		Static++;
	}

	One(sc_module_name name) : sc_module(name)
	{
		Member = 0;
		SC_THREAD(T);
	}
	SC_HAS_PROCESS(One);
};

int One::Static = 0;

class Two : public sc_module
{
    public:
	int a1;
	double b1,b2;
	sc_time t1;
	sc_signal<int> s1,s2;

	void S1()
	{
		a1 = 42;		// SegID 2
		b1 = a1 / 10.0;
		t1 = sc_time_stamp();
		s1 = 13;

		wait(1,SC_NS);		// SegID 3
		t1 += SC_ZERO_TIME;
		s1 = s2;
	}

	void S2()
	{
		// nothing		// SegID 4

		wait(1,SC_NS);		// SegID 5
		Ptr = &Global;

		wait(1,SC_NS);		// SegID 6
		b2 = *Ptr;

		wait(1,SC_NS);		// SegID 7
		*Ptr = b2;

		wait(1,SC_NS);		// SegID 8
		b2 = a1 + b1;
		s2 = s1;
	}

	Two(sc_module_name name) : sc_module(name)
	{
		a1=0;
		b1=0.0;
		b2=0.0;
		t1=SC_ZERO_TIME;
		s1=0;
		s2=0;
		SC_THREAD(S1);
		SC_THREAD(S2);
	}
	SC_HAS_PROCESS(Two);
};

SC_MODULE(TOP)
{
    One m10, m11;
    Two m2;

    SC_CTOR(TOP)
    : m10("m10"), m11("m11"), m2("m2")
    {
    }
};

TOP top("top");

int sc_main(int argc, char* argv[])
{
    printf("data_conflict2 starts\n");
    sc_start();
    assert(Global==42);
    assert(Ptr==&Global);
    assert(top.m10.Member==42);
    assert(top.m11.Member==42);
    assert(top.m10.Static==2);
    assert(top.m11.Static==2);
    assert(top.m2.a1==42);
    assert(top.m2.b1==4.2);
    assert(top.m2.b2==42+4.2);
    assert(top.m2.t1 == SC_ZERO_TIME);
    assert(top.m2.s1 ==  0);
    assert(top.m2.s2 ==  0);
    printf("data_conflict2 done\n");
    return 0;
}

// EOF
