#include "systemc.h"

int global0;
int global1;
int global2;
int global3;

class Interface: public sc_interface {
public:
  virtual void func(int &i) = 0;
};

class Channel: public sc_channel, public virtual Interface {
public:

  Channel(sc_module_name mn):
    sc_channel(mn)
  { }

  int local;
  virtual void func(int &i)
  {
    wait(SC_ZERO_TIME);
    local = 5;
    i = 5;
    wait(SC_ZERO_TIME);
  }
};

class Sender: public sc_module {
public:

  int &ref_sender_;

  sc_port<Interface> port;

  SC_HAS_PROCESS(Sender);

  Sender(sc_module_name mn, int &param):
    sc_module(mn),
    ref_sender_(param)
  {
    SC_THREAD(thread1);
  }

  void thread1()
  {
  int sender_var;
    port->func(sender_var);
    //port->func(ref_sender_);
  }
};

class Receiver: public sc_module {
public:

  int ref_receiver_;

  sc_port<Interface> port;

  SC_HAS_PROCESS(Receiver);

  Receiver(sc_module_name mn, int &param):
    sc_module(mn),
    ref_receiver_(param)
  {
    SC_THREAD(thread1);
  }

  void thread1()
  {
  int receiver_var;
    port->func(receiver_var);
    //port->func(ref_receiver_);
    wait(SC_ZERO_TIME);
    //foo(ref_receiver_);
  }

  void foo(int &param)
  {
    param++;
  }
};

class Top: public sc_module {
public:

  Sender s; // 0
  Sender s1; // 1

  Sender s3; // 2
  Sender s2; // 3


  Receiver r; // 0
  Receiver r1; // 1

  Receiver r2; // 2
  Receiver r3; // 3


  Channel c; // 0
  Channel c1; // 1

  Channel c2; // 2
  Channel c3; // 3

  Top(sc_module_name mn):
    sc_module(mn),
    s("s", global0),
    s1("s1", global1),
    s3("s3", global1),
    s2("s2", global1),

    r("r", global2),
    r1("r1", global3),
    r2("r2", global3),
    r3("r3", global3),

    c("c"),
    c1("c1"),
    c2("c2"),
    c3("c3")
  { }

  void before_end_of_elaboration()
  {
    s.port.bind(c);
    r.port.bind(c);

    s1.port.bind(c1);
    r1.port.bind(c1);

    s2.port.bind(c2);
    r2.port.bind(c2);

    s3.port.bind(c3);
    r3.port.bind(c3);
  }
};

int sc_main(int argc, char **argv)
{
  Top t("top");
  return 0;
}
