#include "systemc.h"

class Module: public sc_module {

public:
  SC_HAS_PROCESS(Module);

  Module(sc_module_name mn):
    sc_module(mn)
  {
    SC_THREAD(thread1);
    SC_THREAD(thread2);
  }

  int x;

  void thread1()
  {
    wait(1, SC_MS);
    wait(1, SC_MS);
    x = 5;
  }

  void thread2()
  {
    x = 6;
  }
};

class Top: public sc_module {
public:

  Top(sc_module_name mn):
    sc_module(mn),
    m1("m1"),
    m2("m2")
  { }

  Module m1;
  Module m2;
};

int sc_main(int argc, char **argv)
{
  Top t("top");
  sc_start();

  return 0;
}
